Reggie, 9.9.1998:
-----------------
- Attributes for writing text can be set with the
  toolbar now. So it's possible to write with defferent
  attributes now.
  I only miss the attribute 'underlined' in KWFormat!
  I'll implement that.
- The attributes, which are shown in the toolbar, are
  automatically updated when moving the cursor.
- There were lots of bugs with calculating the correct font
  width/height when typing characters and moving the cursor.
  I fixed lots of problems here, but I'm sure there are still
  some more. Especially with KWFormatContext::apply() the
  displayFont and the (max)Ascents/(max)Descents were not
  updated. I fixed that.
- I also fixed a bug when breaking lines, so that the cursor
  is placed correctly if it jumps to the next line.
- Fixed a redraw bug.
- Fixed a problem in KWDisplayFont.

Reggie, 10.9.1998:
------------------
- Introduced font attribute UNDERLINE.
- Implemented 'bool KWString::remove(unsigned int _pos,unsigned int _len)',
  'void KWString::append(KWChar* _text,unsigned int _len) and
  'KWChar* KWString::copy(KWChar *_data,unsigned int _len)'
- Implemented 'bool KWParag::deleteText(pos,len)',
  'void KWParag::appendText(KWChar* _text,unsigned int _len)'.

Reggie, 11.9.1998:
------------------
- Implemented Key_Delete and Key_Backspace, and everything which
  was needed for that. There are still lots of problems with that,
  especially with placing the cursor and redrawing.
- Implemented Key_Return (== Key_Enter). It seems to work ok, but I'm sure
  that there are also some problems in it (the same as for Key_Delete and
  Key_Backspace). That's because I'm still not totally fimilar with the
  KWFormatContext. So, Torben, please look at the new implemented
  KeyPressEvents and fix the stuff which I did wrong :-))
- Fixed a bug in "Blocksatz" (avoided division by zero if there are no
  spaces in a line).
- Fixed a bug in freeChar().
- There are bigger problems with alignment center and right. The width of
  a line is not calculated correctly - we have to find a way to do that
  quite fast _and_ correctly.

Reggie, 13.9.1998:
------------------
- Implemented KWFormatCollection, and it's already working
- fixed a bug in "Blocksatz"

Reggie, 14.9.1998:
------------------
- Fixed finally THE bug in KWString :-)
- Totally integrated KWFormatCollecion
- Fixed a bug in backspace
- Fixed a bug with joining paragraphs
- Fixed a redraw problem with delete/backspace, but there are still
  problems with setting the cursor.
- Bugfix in printLine
- Bugfix in Key_Delete
- Improoved speed of deleting/inserting text and scrolling the canvas
  (now only the visible text is repainted)
- Some bugfixes in the KWFormatContext and in printing lines

Reggie, 15.9.1998:
------------------
- Fixed a bug with setting formats
- Added some new GUI stuff

Reggie, 16.9.1998:
------------------
- Started working on alignments/flows. Now you can choose the flow
  for the current paragraph via the toolbar, and the toolbar is
  updated automatically when moving the cursor. Now I have to
  work on the implementation of CENTER and RIGHT, this is really
  broken at the moment...

Reggie, 17.9.1998:
------------------
- Started working on CENTER flow
- Started writing a dialog for paragraph settings

Reggie, 18.9.1998:
------------------
- Worked on paragraph settings dialog (started a cool preview widget)
- Fixed a redraw problem (with setting some clippings)

Reggie, 19.9.1998:
------------------
- Worked on paragraph settings dialog
- Some improvements with linebreaking
- Fixed bug in cursor navigation
- Fixed bug in "Blocksatz"

Reggie, 20.9.1998:
------------------
- Implemented configurable left indent and first line left indent
- Fixed some bugs in cursor navigation
- Fixed a bug in Key_Backspace
- Automatically recalc/update of the cursor, if a new page/paragraph layout is set

Reggie, 21.9.1998:
------------------
- Using new interactive KoRuler (which I started writing today) instead of KRuler.
- First trial of linespacing...

Reggie, 22.9.1998:
------------------
- Fixed a bug in Key_Enter
- Implemented more ruler stuff (this works great now :-)
- Cleaned some GUI stuff

Reggie, 23.9.1998:
------------------
- Indents are configuarble with the ruler now
- Fixed a bug with indents and makeing the line format (line-breaking)
- Another fix with indents and redrawing

Reggie, 24.9.1998:
------------------
- Started implementing: Insert, display and format pictures as character.
  It already works somehow...

Reggie, 25.9.1998:
------------------
- More work on pictures as characters

Reggie, 26.9.1998:
------------------
- Fixed some problems with deleting Text (Key_Delete/Key_Backspace) and
  linebreaking
- Improved KFormatContext::makeLineLayout() to make the linebreaking more
  precise and to make it work correctly with special characters (like pictures)

Reggie, 28.9.1998:
------------------
- Added JPEG filter
- some fixes

Reggie, 29.9.1998:
------------------
- Bugfix with drawing the cursor

Reggie, 30.9.1998:
------------------
- Started implementing placing the cursor with the mouse (but it doesn't do
  anything at the moment...)

Reggie, 1.10.1998:
------------------
- Cursor style is changing according to the font attribute of the current place
- Placing the cursor with the mouse works now

Reggie, 2.10.1998:
------------------
- Implemented selecting text with the mouse
- Implemented deleting selected text and replacing
  selected text with an entered character
- Implemented selecting text with the keyboard (cursor-keys + Shift)

Reggie, 3.10.1998:
------------------
- Bugfix with setting the format for multiple characters
- Implemented selection a word with a mouse double click
- The flows CENTER and RIGHT work now => ALL flows work now :-)
- Fixed a bug in cursor navigation
- Automatical scrolling when selecting text
  (there are some redraw problems when selecting text now because of the
   automatical scrolling)
- Some bugfixes in KWFormatContext

Reggie, 4.10.1998:
------------------
- Bugfix with calculating correct line heights (ascender/descender)
- Bugfix with setting the formats correctly
- I think I fixed now all redraw problems when selecting text
  (it's flickering now a bit, but I'll fix that too one time :-)
- Implemented simple Cut&Copy (ASCII text)

Reggie, 5.10.1998:
------------------
- Some cleanups
- Bugfixes in copy to clipboard
- Implemented Paste (ASCII text)
- Bugfix in cursor navigation

Reggie, 6.10.1998:
------------------
- Implemented tab for setting the flow in the paragraph settings dialog
  (I also wrote a nice preview widget for that :-)

Reggie, 7.10.1998:
------------------
- Worked a lot on speed. Now editing documents and pasting is _much_ faster.

Reggie, 8.10.1998:
------------------
- Fixed paint-methode to paint really all visible paragraphs
- Fixed a redraw bug with multiple columns
- Only draw visible lines now
- Fixed a bug in KWFormatContext::cursorGotoPos(...)
- Bugfix in paste
- Fixed another redraw bug

Reggie, 9.10.1998:
------------------
- Small fixes
- Implemented setting the format for a selected text
- Fixed an awful bug when changing the format
- Linespacing works correctly now
- Bugfix with placing pictures
- Implemented subscript
- Implemented superscript
- Implemented space before/after paragraphs

Reggie, 10.10.1998:
-------------------
- Implemented drawing (configurable) borders around paragraphs
- Bugfix with space before/after paragraphs
- Fixed a redraw bug in backspace/delete
- When placing the cursor with the mouse the format/text toolbar
  is updated correctly too now

Reggie, 11.10.1998:
-------------------
- Implemented saving documents (XML)

Reggie, 12.10.1998:
-------------------
- Fixed a bug with a painter which I forgot to end
- Started implementing loading of documents (XML)

Reggie, 13.10.1998:
-------------------
- Finished implementation of loading documents
- Fixed some bug in saving documents
- Fixed a bug in KWParagLayout::operator=()
- Changed the way to configure the borders of the parags using the toolbar

Reggie, 16.10.1998 - 19.10.1998
-------------------------------
- Made KWord frame orientated instead of page orientated - these were _BIG_ changes
- Everything which worked before the page-orientation -> frame-orientation changes, works again now
- Implemented templates
- Started implementation of printing (at the moment, only the dialog opens :-)
- Fixed lots of speed problems in KWFormatContext when editing long textes. It was terribly slow.
  But it's possible that I introduced some bugs - if this is the case I'll, of course, fix them :-)
  What I did: KWFormatContext::init(..) is called quite often when navigating with the cursor (e.g
  a line up, deleting/inserting text, etc.).
  The implementation of this init methode started at the first parag of the text and went through
  _all_ paragraphs, until the needed one was reached. For long textes (I tested with 70 pages) this was
  damn slow when you were nearly at the end of the text. Now init doesn't go through all parags anymore
  if it is not really needed (and it is nearly never needed!). So this is much faster now.

Reggie, 20.10.1998:
-------------------
- Some cursor navigation and calculation fixes in KWFormatContext
- Some small fixes in KWPage
- Bugfix when loading files

Reggie, 21.10.1998:
-------------------
- Implemented printing documents
- fixed some cursor navigation bugs when pressing return

Reggie, 22.10.1998:
-------------------
- Some cursor navigation improvments and redraw fixes

Reggie, 23.10.1998:
-------------------
- Started implementing that text can flow around other frames. It
  already works somehow :-))

Reggie, 24.10.1998:
-------------------
- More work on text flow around frames

Reggie, 25.10.1998:
-------------------
- Implemented selecting multiple frames
- Implemented moving frames

Reggie, 26.10.1998:
-------------------
- Implemented resizing frames
- Added a new property for framesets, which allows the user to say,
  if a frameset should automatically add frames when the text of
  the frameset doesn't fit into the frames anymore
- Started writing a dialog for configuring frames and framesets. Currently
  it's possible to set the text run-around type for frames and the above
  described property for framesets

Reggie, 27.10.1998:
-------------------
- Implemented Run Around Gap
- Added the possibility to set the Run Around Gap for each frame
  with the frame setting dialog

Reggie, 1.11.1998:
------------------
- Lots of fixes
- It's possible to choose the editing mode with the toolbar and menu now

Reggie, 2.11.1998:
------------------
- Fixed a bug when loading files with more than one framesets
- Some fixes in the toolbars

Reggie, 3.11.1998:
------------------
- Started implementing creating textframes with the mouse. It already works somehow.

Reggie, 4.11.1998:
------------------
- Fixed some bugs with moving/resizing frames
- Inserting text frames works now (quite :-) correctly
- When changing something with frames/framesets they get updated correctly now

Reggie, 5.11.1998:
------------------
- Implemented inserting freely placeable pictures (picture frames)
- Some fixes with moving/resizing frames again
- Implemented printing of freely placeable pictures too
- Fixed a redraw-bug when scrolling the canvas

Reggie, 6.11.1998:
------------------
- Replaced all QRect, QSize and QPoint with KRect, KSize, KPoint. This fixes
  lots of calculation bugs with long documents.
- Fixed another bug with resizing frames

Reggie, 7.11.1998:
------------------
- Implemented saving/loading picture frames (currently it only saves filenames)
- Fixed many, many bugs

Reggie, 12.11.1998:
-------------------
- Scrolling is faster now (esp. for long documents)

Reggie, 14.11.1998:
-------------------
- ptYEnd is set correctly for each paragraph now
- setting the text cursor with the mouse and selecting text with the mouse is faster for long textes now
- started implementing style templates
- the number of pages is calculated correctly now

Reggie, 15.11.1998:
-------------------
- More work on style templates

Reggie, 16.11.1998:
-------------------
- More work on the stylist (style editor, style manager, ...)

Reggie, 18.11.1998:
-------------------
- Added tab to the paragraph layout dialog for configuration of paragraph borders
- Use this border config tab in the stylist too

Reggie, 19.11.1998:
-------------------
- Started adding tab to the paragraph layout dialog for configuration of numbering (different list types and chapter numbering)
- Use this tab in stylist too
- Started implementing of internal stuff for using style templates in the documents

Reggie, 20.11.1998:
-------------------
- More work on numbering (internal stuff and configuration dialog)

Reggie, 21.11.1998:
-------------------
- Worked a lot on numbering - it starts really working now :-)

Reggie, 22.11.1998:
-------------------
- Applying style templates works (this means chapter numbering, all types of lists, etc. is possible now :-)
- Modifying style templates in the stylist works - but the text doesn't get updated at the moment (this will come)
  The style template stuff starts working now - there are still lots of bugs and problems in it on which I will
  work tomorrow.

Reggie, 23.11.1998:
-------------------
- Fixed some code which produced memory leaks
- The following style template (parag layout) can be defined
- Applying/Updating style templates much works better now (but I have still to do some stuff here)
- More internal work (esp. fixes) with style templates

Reggie, 24.11.1998:
-------------------
- More work on updating/applying style templates. It works quite well now.
- Some fixes in calculation of the chapter numbers, lists, etc.
- Enumerated lists and Bullet lists can be easily used using the toolbar now.

Reggie, 25.11.1998:
-------------------
- Style Templates are saved and loaded now
- Initialization of the GUI work correctly now
- New Style Templates can be added

Reggie, 26.11.1998:
-------------------
- Adding new style templates works correctly now
- Removing style templates works now
- Setting the numbering stuff for paragraphs works correctly now

Reggie, 27.11.1998:
-------------------
- Lots of fixes
- Did some speed improvments - it's noticeable faster now :-)

Reggie, 28.11.1998:
-------------------
- Lots of fixes again
- Fixed some memory leak producing code (which made KWord really slow too)
- Much more speed improvements
- Improved "Blocksatz" - it doesn't wobble anymore :-)
- Fixes with scrolling/redraw

Reggie, 29.11.1998:
-------------------
- Fixes
- Return/Enter should be faster now

Reggie, 30.11.1998:
-------------------
- Scrolling works fine again
- Lots of fixes again

Reggie, 1.12.1998:
------------------
- More speed improvements
- Selecting text is faster too now (There are still problems when selecting text with the mouse
  and scrolling - selcting text with keyboard + scrolling works quite fine)
- Small fixes again

Reggie, 2.12.1998:
------------------
- Fixes with style templates
- Fixes and improvements with numbering/lists (now even roman numbers can be used for numbering/lists :-)
- New Icons
- Keyboard shurtcuts in the menus

Reggie, 3.12.1998:
------------------
- Fix with following parag layouts, format updating, etc.
- Fix with placing cursor with the mouse
- If multiple underlined words are written the spaces between are underlined too now

Reggie, 4.12.1998:
------------------
- When the width of a word is larger than the width of the frame, the kernel
  stays cool and doesn't get confused anymore :-)
- When the frame width < rastX (e.g. because other frame(s) are overlapping so much and the user
  enabled 'runaround') the next line is drawn a bit more down (where we have enough space again)

Reggie, 5.12.1998:
------------------
- Started with tabulators
- Improved Style Templates
- Improved applying/updating Style Templates
- Fixed frame calculations

Reggie, 6.12.1998:
------------------
- More work on tabulators (left aligned tabs work already somehow)
- Fixed a bug with loading/saving docs (now it doesn't crash anymore when loading special objs like pictures)

Reggie, 7.12.1998:
------------------
- More work on left aligned tabs, but there is still a bug

Reggie, 8.12.1998:
------------------
- added 'jpeg' to the 'All pictures' filter in the file dialog
- Fixed a bug with this "magic first character"
- Using ICON() for loading icons in whole KWord
- Save as works again
- When loading a file the toolbar and rulers are update correctly at the beginning

Reggie, 9.12.1998:
------------------
- Templates are searched in the local kdedir (~/.kde/share/apps/kword/templates) now too
- More work on tabs (started with right aligned tabs)

Reggie, 11.12.1998:
-------------------
- When applying paragraph settings and multiple paragraphs are selected, the settings
  are applied to all selected paragraphs.

Reggie, 12.12.1998:
-------------------
- Improvements with inserting/creating objects

Reggie, 13.12.1998:
-------------------
- More work on right aligned tabs (still not working well...)
- Some fixes

Reggie, 14.12.1998:
-------------------
- Implemented showing of formatting chars
- Showing formatting chars / frame borders is configurable now

Reggie, 15.12.1998:
-------------------
- More work on tabulators
- Started with embedded objects (just internal stuff at the moment)
- DTD is installed to $KDEDIR/share/apps/kword/dtd/kword.dtd

Reggie, 16.12.1998:
-------------------
- Started with centered tabulator (already works)
- More work on embedding parts (creating, saving/loading, moving/resizing and activating/deactivating works now)
- Implemented printing embedded parts

Reggie, 17.12.1998:
-------------------
- Internal work and lots of fixes

Reggie, 18.12.1998:
-------------------
- Started with headers and footers (it's not working yet!)

Reggie, 19.12.1998:
-------------------
- More work on headers and footers

Reggie, 20.12.1998:
-------------------
- Internals of headers and footers are working now - tomorrow the visible (and useable :-) part
  and saving/loading will follow

Reggie, 21.12.1998:
-------------------
- Fixes with loading/saving docs
- More work on the internals of headers/footers (don't try it out yet - it crashes very often)

Reggie, 22.12.1998:
-------------------
- Simple headers/footers are working
- Implemented printing headers/footers
- Text of parags should be saved with <TEXT>Some Text here</TEXT> now and not with <TEXT value="Some Text here"/> anymore.
  The old version (<TEXT value="..."/>) is still supported for compatibility, but really shouldn't be used anymore.
  (Of course KWord itself saves text with <TEXT>...</TEXT> now too :-)

Reggie, 23.12.1998:
-------------------
- Fixed a bug when loading framesets with no text (1 parag with textlen == 0)
- Implemented loading/saving headers/footes (Kalle, I'll send you a mail with the new tags/attributes)
- Some fixes
- Different footer/header for first page and the rest of the doc start working now (there are still some problems)

Reggie, 25.12.1998:
-------------------
- Different footer/header for first page and the rest of the doc are working fine now (also for printing)
- Fixes when loading headers/footers
- Different headers/footers for even and odd pages works now

Reggie, 26.12.1998:
-------------------
- Printing of different headers/footers of even and odd pages works now
- Bugfixes

Reggie, 27.12.1998:
-------------------
- Speed improvements again (now the number of used fonts/formats doesn't influence the speed anymore)
- Worked a bit on the DTD
- Reorganized UI of stylist (with german translation ig got much too wide)
- Started implementing spellchecking

Reggie, 28.12.1998:
-------------------
- More work on spell checking
- Started with the tab for tabulator settings in the parag layout dia
- Some small fixes

Reggie, 29.12.1998:
-------------------
- Fixes with tabulators and moving/resizing frames/borders

Reggie, 30.12.1998:
-------------------
- Cleanups
- Implemented internals for searching and replacing text (will be used for autoformat too)

Reggie, 1.1.1999:
-----------------
- More work on searching and replacing text (internals seems to work now - only the dialog is missing :-)

Reggie, 3.1.1999:
-----------------
- Started with search & replace dialog
- Simple searching (without formats) with the dialog works

Reggie, 4.1.1999:
-----------------
- Implemented searching with formats
- Lots of fixes (updating the rulers seems to work correctly now :-)

Reggie, 5.1.1999:
-----------------
- Fixes
- Searching for whole words only works now

Reggie, 6.1.1998:
-----------------
- Fixed this annoying redraw bug when deleting text. If you delete text in a frame the overlapping frames are not
  deleted (on the screen) anymore
- Fixed some more redraw bugs
- Last imput in the search dia is remembered
- Implemented searching backwards (also with formats)

Reggie, 7.1.1999:
-----------------
- Added filedialog preview widgets for pictures and cliparts
- Started with replacing text (with the dialog - somehow I have to decrease the size of this dialog)

Reggie, 8.1.1999:
-----------------
- Decreased size of search/replace dialog a bit
- It's possible to use regular expressions and wildcards for searching now
- Initialization of vertical ruler works correctly now too
- More work on internal stuff for replacing text

Reggie, 9.1.1999:
-----------------
- Some more work on replacing text

Reggie, 10.1.1999:
------------------
- Fixed some memory leak producing code
- Find&Replacing works (with formats)

Reggie, 11.1.1999:
------------------
- Implemented 'replace all'

Reggie, 12.1.1999:
------------------
- Started with tables:
  - Implemented internals for tables (a table consists of (rows * cols) framesets, each frameset has one frame)
  - Inserting tables works (I'll add a widget for choosing the number of rows and cols tomorrow)
  - Writing text in the tables and formatting works
  - Moving tables works
  - Resizing rows and cols works
  - Selecting cells works

Reggie, 13.1.1999:
------------------
- Tons of fixes and improvements
- Improvements for tables and headers/footers
- If the text of a frameset doesn't fit into the frames anymore, and no new frames should be appended,
  the last frame gets, if possible, automatically resized now (this is default for table cells and headers/footers)
- Cleanup of framedia

Reggie, 14.1.1999:
------------------
- Fixes
- When inserting a new parag (after pressing return) and current paragLayout->name() == following paragLayout->name()
  a copy of the current paragLayout is assigned to the new parag.
- Tables can flow over multiple pages now
- Saving and Loading tabes works now
- Destructor doesn't crash anymore :-)) (at least on my system)

Reggie, 15.1.1999:
------------------
- More work on table flowing over multiple pages
- Some fixes with moving/resizing frames
- Added dialog for initial table settings and configurating tables (currently only used for initial settings)
- replacing KNumericSpinBoxes with QSpinBoxes, because QSpinBoxes look much nicer

Reggie, 17.1.1999:
------------------
- Fix of a strange bug in KWordView::colorToPixString
- Some other small fixes
- Added menu switch for enabling/disabling showing of table grid
- Selecting multiple frames (esp. table cells) is more comfortable now
- It's possible to configure borders (color, width and style) for frames now => table cells can have these borders too
- Implemented loading/saving frame borders
- Implemented printing frame borders

Reggie, 18.1.1999:
------------------
- Some formatting fixes
- Preperations for more formatting and settings of frames and tables

Reggie, 19.1.1999:
------------------
- Code cleanups
- Internal work for background colors of frames
- Fixes when moving around frames to avoid crashes
- Fixed (or worked around :-) the strange bug when saving embedded objects

Reggie, 20.1.1999:
------------------
- Changed the toolbar pixmaps for choosing colors, which get automatically generated - they show now for what you choose the color
- Setting background colors for frames works
- setting the ranges of scrollbars is correctly now (no maxrange > minrange warnings anymore)
- Loading, Saving and Printing background colors of frame works

Reggie, 21.1.1999:
------------------
- Selecting multiple cells in a table is more comfortable
- Some more fixes to avoid crashes when inserting objects
- Fixed saving/loading background colors of frames

Reggie, 23.1.1999:
------------------
- Added menu and toolbar for table settings
- Added dialog for inserting rows/cols in tables
- Implemented inserting rows in tables
- Implemented inserting columns in tables

Reggie, 24.1.1999:
------------------
- If the cursor is in a table, CTRL-Return inserts a new row below the row, where the cursor currently is
- If the cursor is in a normal text frame, CTRL-Return makes a hard break (jumps to next frame)
- Added menu item for inserting a hard frame break

Reggie, 25.1.1999:
------------------
- Added dialog for deleting rows/cols in tables
- Implemented deleting rows and columns
- Did some internal stuff for margins in frames
- Some fixes and improvements in saving/loading
- Frame margins can be saved/loaded now
- Another fix with embedded objects
- Non-textframes can have borders too now

Reggie, 26.1.1999:
------------------
- Added saving/loading hard frame breaks (seems that I forgot that...)
- Frame-Margins work now (only the dialog for setting them is missing :-)
- Fixed some memory leak producing code (I haaaaaate destructors)
- Some fixes with drawing borders of frames, but this is still not correct

Reggie, 27.1.1999:
------------------
- Improved drawing frame borders again (now the PS output looks ok too)
- More error checking when inserting tables
- Now multiple frames/framesets can be configured using the dialog at the same time
- Added tab in the frame/frameset settings dialog for geometry (fram coordinates + frame margins)
- It's possible to set and modify frame coordinates and margins using the dialog now
- Tables have a default margin of 2 pts.

Reggie, 28.1.1999:
------------------
- Fixes when loading documents
- It's possible to set the linespacing using the toolbar now
- Fixed drawing paragraph borders
- Some other small fixes
- Frame/Frameset dialog can be opened using the menu now too
- Some speed imporvements when ptWidth < rastX because of overlapping frames

Reggie, 29-30.1.1999:
---------------------
- All values in KWord can be given in inch, mm or pt now. For that I had to quite big changes and change
the file format a bit, but old files can still be loaded
- Switching to another unit is currently only possible with a right click on the ruler and choosing
  the unit in the popup menu there
- Fixes with printing (textframes with num > 0 on pages > 0 were not printed)

Reggie, 31.1.1999:
------------------
- Some small cleanups und fixes
- Fixes with loading old kword files
- More fixes with printing
- Many fixes with drawing frame borders, headers/footers, etc.
- Fixes with automatically adding new pages
- Fixes with inserting new frames

Reggie, 1.2.1999:
-----------------
- Started with internal stuff for variables (pagenum, date, etc.)

Reggie, 2.2.1999:
-----------------
- Started with a document structure viewer. This is placed at the left of the canvas (can be hided)
  Currently it's hided by default, since it's still useless :-) Use View->Document Structure to show it
- The document structure viewer will show a hirarchical arrangement of chapters, all pictures, tables,
  embedded objs, etc. in a structured tree view. It will also be possible to rearrange the document
  there and if you click on a item you will get to this part of the text in the canvas.
  Currently you will not see much :-)

Reggie, 3.2.1999:
-----------------
- Small fix with setting page borders on rulers
- Showing the paragraph arrangement (Gliederung) of the text framesets
  in the document structure viewer works
- The document structure viewer isn't updated automatically at the moment - just
  close and open the "Arrangement" branch to update it
- Added a demo document with some chapters and different depths to demonstrate
  the document structure viewer

Reggie, 4.2.1999:
-----------------
- Double click on a paragraph branch in the arrangement branch of the document
  structur viewer sets the cursor to this paragraph in the text view
- Text frames and text frame sets are listed in the docu structure viewer
- Tables are listed in the docu structure viewer
- Pictures are listed in the docu structure viewer
- Embedded objects are listed in the docu structure viewer

Reggie, 5.2.1999:
-----------------
- Double click on a text frame branch in the document
  structur viewer scrolls to this text frame in the text view
- Double click on a table branch in the document
  structur viewer scrolls to this table in the text view
- Double click on a picture branch in the document
  structur viewer scrolls to this picture in the text view
- Double click on a embedded object branch in the document
  structur viewer scrolls to this embedded object in the text view
- Fix with activating an embedded part
- Loading embedded parts doesn't crash anymore

Reggie, 6.2.1999:
-----------------
- More work on variables

Reggie, 7.2.1999:
-----------------
- Small fix in printLine

Reggie, 11.2.1999:
------------------
- Started with undo/redo
- Added copy constructor for KWParag

Reggie, 16.2.1999:
------------------
- Undo/Redo starts working
- Some fixes with formatting

Reggie, 17.2.1999:
------------------
- More undo/redo

Reggie, 18.2.1999:
------------------
- When a table flows over multiple pages the header (= first row)
  is shown on the beginning of the table part on each page. I'll
  add the possibility to switch this on/off - now it's on by
  default. Only the automatically added headers are not up-to-date
  all the time currently - I'll fix that.

Reggie, 24.2.1999:
------------------
- When a table flows over multiple pages and the table-header is copied to
  each page, it is updated correctly now.

Reggie, 25.2.1999:
------------------
- Fixed some segfaulting code
- Fixed some memory leaking code
- Table headers get really updated correctly now - there is only a repaint problem there now...

Reggie, 26.2.1999:
------------------
- Nearly fixed redraw problem when updating temp table headers
- Margins, borders, background colors, etc. of temp table headers are updated correctly now
- Started with more configuration possibilities for tables
- Some fixes with adding/removing temp table headers and cells in general

Reggie, 27.2.1999:
------------------
- Some more fixes in tables

Reggie, 28.2.1999:
------------------
- Much more work on variables

Reggie, 1.3.1999:
-----------------
- Implemented date variable and date variable format
- Implemented inserting variables (works with date variables)
- Some fixes in formatting text

Reggie, 2.3 - 6.3 1999:
------------------
- Porting to Qt 2.0 and lots of fixes for that

Reggie, 7.3.1999:
-----------------
- Never make the pixmap for double buffering larger than necessary
- Some fixes with events and key compression
- Implemented inserting variable date vars and page num vars
- Lots of fixes in variables

Reggie, 8.3.1999:
-----------------
- Improved speed when the whole doc has to be recalculated
  (there may be some redraw problems now, but I couldn't find some)
- Fixes in cursor navigation
- Implemented inserting variable and fix time variables

Reggie, 9.3.1999:
-----------------
- Small fix in the GUI
- Fixed hopefully most of the focus problems now

Reggie, 10.3.1999:
------------------
- Fixes

Reggie, 11.3.1999:
------------------
- Implemented KWordDrag which will be used for storing data on the clipboard and for DnD
- Using new features (QMimeSource stuff) of the QClipboard
- Text is copied as text/plain and in native KWord format (application/x-kword) to the clipboard (using KWordDrag as QMimeSource)
  (only partly implemented)
- When pasting text: If native KWord format (application/x-kword) is provided, this is used, else text/plain is used
  (only partly implemented)
=> when cut/copy/pasting between or in KWord documents, formatting is copied/pasted too now

Reggie, 12.3.1999:
------------------
- Some fixes
- Some more work on pasting text
- Some more fixes

Reggie, 16.3.1999:
------------------
- Some fixes
- More work on cut/copy/paste

Reggie, 17.3.1999:
------------------
- Fixes in tables
- Improved variables

Reggie, 18.3.1999:
------------------
- Implemented saving of different types of variables
- Some fixes in variables

Reggie, 19.3.1999:
------------------
- Fixed saving variables
- Some fixes and improvements in variables
- Using QChar instead of char in the KWString class now => KWord supports Unicode (at least I hope so :-)
- edit->paste gets enabled/disabled according to the clipboard data
- edit->copy/cut gets enabled/disbaled according to the text selection

Reggie, 20.3.1999:
------------------
- Fixes
- Fixed saving variables
- Implemented loading variables

Reggie, 21.3.1999:
------------------
- Copying multiple paragraphs with formats to clipboard works
- Some fixes and improvements in pasting formatted text

Reggie, 22.3.1999:
------------------
- Pasting multiple paragraphs with formats works

Reggie, 23.3.1999:
------------------
- Changed the toolbar pixmap which shows the text color - much nicer now
- Fixes in the GUI
- Started with internals for joining/splitting cells

Reggie, 24.3.1999:
------------------
- Added menu entry for splitting table cells
- Improved Tables:
  - It's possible to ungroup a table (each cell becomes an own frameset - ok,
    they are always own frame sets, but the table manager stops controlling them
    in this case)
  - More internal work for joining/splitting table cells

Reggie, 25.3.1999:
------------------
- More work on joining table cells:
  - Joining in horizontal direction works sort of - but
    some strange things are still going on here ;-)
- Made some menu items functional

Reggie, 26.3.1999:
------------------
- Joining table cells in horizontal direction works quite well now
  (at least it doesn't crash anymore and resizes correctly :-)

Reggie, 27.3.1999:
------------------
- Implemented joining table cells in vertical direction
  (only the auto-resize of vertical joined table cells screws
   up a table a bit - will fix it)

Reggie, 28.3.1999:
------------------
- Clicking on joined/hidden tables cells works correctly now
- Some menu items/toolbar pics for table manipulations get disabled/enabled
  correctly to avoid mistakes by the user

Reggie, 29.3.1999:
------------------
- For joining cells it's not required anymore to put the cursor
  into the table first
- Implemented splitting cells - this means you can only split a joined
  cell yet, no "normal" cells. I'll improve that later.
- Prepeared everything for context sensitive right button menus

Reggie, 1.4.1999:
-----------------
- Started implementing footnotes and endnotes

Reggie, 2.4.1999:
-----------------
- Some cleanups
- Much more work on footnotes/endnotes

Reggie, 3.4.1999:
-----------------
- More work on footnotes:
  - Inserting simple footnotes works
  - Footnote-Manager calculates/updates numbers correctly
  - Implemented Formatting/Displaying
- Fixed formatting of inserted variables

Reggie, 4.4.1999:
-----------------
- More work on footnotes/endnotes
  - Implemented Removing footnotes/endnotes
  - When removing footnotes/endnotes, the Footnote-Manager
    updates the numbers correctly
  - Speed improvement and fix for calculation the start number of a new footnote
- Improved and fixed some stuff in KWString
- Fix in KWordView::setFormat (doesn't segfault in stupid cases anymore)

Reggie, 5.4.1999:
-----------------
- More work on footnotes/endnotes
- Started with Drag'n'Drop (dragging a selected text from one KWord App and dropping
  it into another KWord App works already somehow)

Reggie, 6.4.1999:
-----------------
- Started with a dialog for inserting a footnote where you can make crazy footnotes
  if you want (like [1,2,3-6,7] and so on)

Reggie, 7.4.1999:
-----------------
- When dropping an image into a KWord page, it's inserted as a picture frame
- When dropping an url(list) into a KWord page the url(s) are opened ("image/*" is inserted as
  picture frame and other mime types are inserted as text for now)
- More work on footnotes

Reggie, 8.4.1999:
-----------------
- When saving text '>' and '<' are converted to &gt; and &lt;
- More work on footnotes/endnotes
  - Adding the footnote description for endnotes works quite well now
    (only in the sorting is a bug...)
- Some fixes and cleanups

Reggie, 10.4.1999:
------------------
- Cleanups
- Footnote/Endnote descriptions are sorted correctly now
- Implemented correct behavior when deleting a footnote/endnote

Reggie, 11.4.1999:
------------------
- A footnote/endnote description paragraph can't be deleted
- footnotes/endnotes don't loose connections to the footnote/endnote description paragraphs
  after sorting them anymore

Reggie, 12.4.1999:
------------------
- Paragraph information and name (if required) gets saved and loaded now

Reggie, 13.4.1999:
------------------
- Fixes

Reggie, 14.4.1999:
------------------
- Implemented saving footnotes/endotes
- Implemented saving footnote/endnote manager
- Implemented loading footnote/endnote manager
- Implemented loading footnotes/endotes

Reggie, 16.4.1999:
------------------
- More work on footnotes/endnotes
- Started with autoformat

Reggie, 17.4.1999:
------------------
- More work on footnote descriptions
- More work on autoformat

Reggie, 18.4.1999:
------------------
- Fix with dropping images into a kword page
- More work on autoformat (started with typographic quotes stuff)

Reggie, 19.4.1999:
------------------
- Made typographic quotes autoformat stuff more efficient
- Started working on more autoformat stuff

Reggie, 20.4.1999:
------------------
- Implemented KWString::utf8() to convert KWStrings to utf8
- KWord saves and loads now in utf8
- More work on autoformat (implemented that annoying automatical conversation
  to uppercase letters :-)

Reggie, 23.4.1999:
------------------
- Implemented autoformat for Upper-Upper -> Upper-Lower
  convert (e.g. convert HAllo to Hallo)

Reggie, 24.4.1999:
------------------
- Improvements in Upper-Upper -> Upper-Lower and
  automatical uppercase conversation
- Started implementing dialog to configure autoformat
- Implemented methodes for configuration of simple autoformat

Reggie, 26.4.1999:
------------------
- Using now the KCharSelect widget of libkdeui for the character selector dialog
- More work on unicode
- More work on configuration and config dialog of autoformat
- Corrected some stuff in the templates

Reggie, 27.4.1999:
------------------
- Renamed Autoformat to Autocorrection in menues and dialogs
  (IMO this is a better name)
- Improved autoformat (now each character knows if it was corrected
  by autoformat, and if yes, it also knows it's original value which
  can be restored if the autoformat gets switched off)
- More work on autoformat configuration

Reggie, 28.4.1999:
------------------
- Some improvements in autoformat
- Fixed a memory leak

Reggie, 29.4.1999:
------------------
- Cursor gets updated correctly after changing autoformat configuration
- Cleanups

Reggie, 30.4.1999:
------------------
- More work on footnote descriptions
- typographic quotes for autocorrection are now configurable

Reggie, 1.5.1999:
-----------------
- Using new features of template dialog

Reggie, 3.5.1999:
-----------------
- Added PNG to filters when opening KFileDialog for opening a pic

Reggie, 4.5.1999:
-----------------
- Use libqimageio if present
- Improvements in the KWString class
- Started with a user defineable autocorrection functionality
  (type in (c) and see what happens :-))
- Fix when template loading goes wrong

Reggie, 6.5.1999:
-----------------
- Implemented blinking cursor
- Disabled Undo/Redo for now (it's broken at the moment)

Reggie, 12.5.1999:
------------------
- Fixed and improved Drag'n'Drop
- Fixed a problem with blinking cursor
- Implemented configuration class for advanced autocorrection

Reggie, 14.5.1999:
------------------
- Big code cleanups:
  - As my coding style was hard to read I started using a better one
  - Fixed includes (Only really neccessary headers are included in the .h files)

Reggie, 15.5.1999:
------------------
- More cosmetic fixes (mainly using a better readable coding style)

Reggie, 16.5.1999:
------------------
- Fixed some problems with toolbar icons

Reggie, 18.5.1999:
------------------
- QChar related fix

Reggie, 21.5.1999:
------------------
- The whole document needs to be calcualted at the beginning
  and when the pageformat changes
  (although this may take a bit long for large docs)
- Fixed loading templates and loading docs using the template dialog (Also stores and embedded parts
  are loaded in these cases correctly)

Reggie, 24.5.1999:
------------------
- Advanced autocorrection starts working :-)
  (It's now a bit more flexible). Only the
  configuration dialog is missing...

Reggie, 25.5.1999:
------------------
- More work on advanced autocorrection
- Started with configuration of advanced autocorrection

Reggie, 28.5.1999:
------------------
- Some QStrList -> QStringList

Reggie, 29.5.1999:
------------------
- Fixed some problems with loading/saving strings. Now
  inserting Endnotes works again too.

Reggie, 30.5.1999:
------------------
- Fixed a formatting bug for lines in "blocksatz" which contain special chars (vars, footnotes, ...)
- Improved configuration of advanced autocorrection
- Fixed splitting table cells
- Saving tables with splitted/joined cells works now

Reggie. 1.6.1999:
-----------------
- Pixmaps are saved inline now (using koStore), but
  not loaded yet that way...
- Some minor fixes

Reggie, 3.6.1999:
-----------------
- When pasting/dropping text the new parags are calculated
  correctly => correct painting. It's a bit slow now if you
  paste/drop text at the beginning of a very long document,
  but I'll optimize that one day too :-)

Reggie, 5.6.1999:
-----------------
- KRect/KPoint/KSize -> QRect/QPoint/QSize

Reggie, 6.6.1999:
-----------------
- Checking some values to avoid crashes in
  KWFormatContext::selectWord()

Reggie, 7.6 - 9.6 1999
----------------------
- As quite some code of KWord was real a mess, I
  started with a big cleanup:
  - KWPage is now a QScrollView (no scrolling magic in KWord anymore :-)
  - No double buffering for painting anymore (this was too slow and
    used too much memory). But most of the painting stuff is already
    quite flicker-free, although it's painted directly without double
    bufferning - but I'll work on that a bit more
  - No open QPainters are passed around in the KWFormatContext anymore,
    as these painters were not needed anymore since a long time now => I
    could remove the hacks to avoid two opened painters at one paint device
  - Reorganized/Rewrite some code in KWPage => no doubled code there anymore
  - Selecting text flickers not that much anymore (I'll also work on that more)

BUTTTTHH (tm): I didn't test it lot yet, so many things are for sure broken. I'll do
testing + fixing + more cleanups from now on

Reggie, 10.6.1999:
------------------
- More cleanups in KWPage
- Selecting text with the keyboard is nearly completly
  flicker-free now :-))
- Started re-implementing autoscrolling and selecting
  text when setting/moving the cursor with the mouse
  (but doesn't work at all at the moment :-P )

Reggie, 11.6.1999:
------------------
- Some more flicker-freeness (there are some redraw errors now, I'll keep working on that)
- Initial position of vert. scrollbar is correct now
- Made some broken stuff working again

Reggie, 13.6.1999:
------------------
- Text edit mode is now (more or less) totally flicker-free. In the other modes
  there are still lots of redraw errors, but fixing that is the next step.
- Small improvements for more efficient drawing

Reggie, 14.6.1999:
------------------
- More work on flicker-freeness and optimations
- tell dialogs about their parent, so that the window manager
  can do some optimations

Reggie, 15.6.1999:
------------------
- Reimplemented autoscrolling when setting the cursor with the mouse

Reggie, 17.6.1999:
------------------
- Cleanups
- Fix in autoscrolling with the mouse (doesn't hang anymore)
- Started reimplementing selecting text with the mouse
  (don't try it yet, it's make lots of drawing errors :-)

Reggie, 18.6.1999:
------------------
- Cleanups
- ASCII import works :-)

Reggie, 19.6.1999:
------------------
- Fixed initial repaint problem
- Saving/Loading pictures into/from a document finally
  works now

Reggie, 20.6.1999:
------------------
- Selecting/Deselecting Frames works correctly again
- Selecting/Deselecting Table cells works correctly again
- When moving/resizing frames, repaints are correct
- Some other small fixes
- Fixed a crash in the KWImageCollection

Reggie 21.6.1999:
-----------------
- Use filter manager for Save As too (to be able to export files)
- Implemented very simple and limited ASCII export
- fixes for drawing selection
- Cut&Copy&Paste works again

Reggie, 22.6.1999:
------------------
- Activating/Deactivating embedded parts works now
  (no crashes anymore :-)
- Fixed a crash in the document structure viewer

Reggie, 29.6.1999:
------------------
- Fixed some redraw bugs I found in KL.
- Removed some focus hacks

Reggie, 1.7.1999:
-----------------
- Improved image handling => Fixed also loosing
  inlined saved pictures in some cases

Reggie, 3.7.1999:
-----------------
- Fixed creating, moving and resizing frames
- When connection a frame to a frameset, only
  the framesets, to which a frame can be connected,
  are listed
- Framesets have now unique names, which the user
  can (has to) specify - this makes working with
  multiple framesets easier for users
- Implemented deleting frames, framesets and tables
- Some minor fixes

Reggie, 4.7.1999:
-----------------
- Implemented reconnecting frames
- Some fixes

Reggie, 13.7.1999:
-----------------
- Code cleanups
- Improved pasting (it make a format diff like M$-Word now)

Reggie, 13.7.1999:
-----------------
- Tabs (Tab key) works again

Reggie, 14.7.1999:
------------------
- Improved DnD a lot

Reggie, 4.8.1999:
-----------------
- Don't allow to connect new frames with framesets of a table

Reggie, 9.8.1999:
-----------------
- Enabled filters again
- Fixed some more redraw errors (clear empty areas)
  (there are still lots of redraw errors and somtimes too much redraws - I
   think I have enough todo for the next days :-)

Reggie, 10.8.1999:
------------------
- Got rid of some useless redraws
- Found the bug which has eaten Key_Enter/Key_Return sometimes and fixed it

Reggie, 11.8.1999:
------------------
- Got rid of some more useless redraws
- Fixed most of the formatting errors. The problem was that the stuff
  below contentsY() + visibleHeight() + somePixels never got formatted if something
  changed (e.g. input of text). When scrolling the new stuff was reformatted on the fly,
  BUTTT when the scrollingValue was larger than visibleHeight() this didn't work anymore
  and the formatting was fucked up. Now using a null-timer KWord formats this stuff below
  in the background in steps of 15 lines. The result is really good! There are still some
  small problems (the timer is not always started when it should and so on). Also this formatting stuff
  is only done for the frameset, in which the user is working at the moment - it should be done for all
  framests. I'll work on these things tomorrow.
- Some other small fixes

Reggie, 12.8.1999:
------------------
- Fixed more redraw and formatting bugs


Reggie, 13.8.1999:
------------------
- Big cleanups and some optimations in KWFormat and KWFormatContext
- We have now always fast access to the empty/drawable region of
  the frame we are working in through the KWFormatContext
- Started using QRegions to always clear empty areas correctly
  (when this QRegion stuff is done most of the remaining redraw errors will
   be fixed :-)

Reggie, 19 - 20.8.1999:
-----------------------
- Fixed much more drawing errors using QRegions. QRegions are really cooool!
  Now all big drawing and formatting errors seem to be fixed :-)
- Removed some hacks which are not needed anymore
- Fixed some crashing code

Reggie, 24.8.1999:
------------------
- Fix in framedia
- Implemented inserting custom variables
- Implemented editing values of custom variables
- Some fixes

Reggie, 25.8.1999:
------------------
- Implemented saving and loading of custom variables

Reggie, 26.8.1999:
------------------
- Cleanups

Reggie, 29.8.1999:
------------------
- Fixed a redraw bug (always repaint new area when scrolling)
- Some other fixes

Reggie, 31.8.1999:
------------------
- Improved DnD, Copy/Move works now :-)

Reggie, 1.9.1999:
-----------------
- Return/Enter is now more flickerfree
- More redraw improvements
- More optimations of Return/Enter to make it even more flickerfree

Reggie, 2.9.1999:
-----------------
- Small speed improvement

Reggie, 3.9.1999:
-----------------
- Fix in saving text

Reggie, 7.9.1999:
-----------------
- Implemented all internals for serial letters and
  the dialog for inserting serial letter variables.

Reggie, 12.9.1999:
------------------
- More work on serial letters
- Some fixes for pixmaps in new and old fileformat

Reggie, 13.9.1999:
------------------
- Saving/Loading pixmaps follows now the new fileformat SPECS

Reggie, 16.9.1999:
------------------
- More work on the serial letter database (works finally)
- Implemented printing serial letters => everything for serial
  letters works now, only the editor for the serial letter
  database is not working yet

Reggie, 18.9.1999:
------------------
- Fixed a mem leak
- More work on srial letter database editor:
  - It's possible to navigate through the records
  - It's possible to edit entries in a record
  - Adding new records works

Reggie, 19.9.1999:
------------------
- Ooops, internally KWord used QChar for unicode stuff since quite
  some time, but for printing/painting it was converted to char all
  the time. Fixed that now.
- More work on flicker freeness and fixes
- When creating a formula frame, libkformula is used now
- Editing formula frames works now (with double click on it)
  (the current way of using the kformula-toolbar is just temporary,
  I'll make a better solution for this (use a real toolbar :-) )
- Saving/loading/printing formulas works
- Focus handling for editing formulas works well now

Reggie, 20.9.1999:
------------------
- When you are in text edit mode and click on an editable frame, which
  is not a text frame (e.g. formula or OpenPart), you can edit
  this frame (no switch to frame edit mode + double click needed
  anymore)
- More integration of libkformula:
  - A KWord toolbar for furmula editing is now shown/hidden when
    activating/deactivating a formula frame
  - Formatting (font, color, etc.) for formulas works now

Reggie, 21.9.1999:
------------------
- Improved and fixes in updating styles (paragraph layouts):
  - KWord can be much smarter there now
  - It's possible to choose now in the stylist if KWord
    should be smart when updating styles or if the user
    wants to set the options for updating itself
- Code cleanups
- Updating text-toolbar when acivating/deactivating a formula
  frame works now
- Undo/Redo of the formula editor can be used now
- font and color of formulas is saved/loaded now
- some more fixes for formula editing

Reggie, 28.9.1999:
------------------
- Started with online spellchecking. Doesn't do anything
  useful yet.

Reggie, 1.10.1999
------------------
- Implemented automatic generation of Table of Contents
- Some fixes

Reggie, 2.10.1999:
------------------
- Showing formatting chars works now really
- Rewrote frame moving/resizing:
  Until now all handles were drawn using raster op NOT. The
  result were lots of redraw errors and lots of unnecesarry redraws.
  Now the handles are widgets => no redraw problems and
  much less redraws necesarry :-)

Reggie, 3.10.1999:
--------------
- All necesarry operations work now in the serial letter
  database editor (removing records or entries crashes sometimes,
  looks like a QValueList prob. - IŽll look into that later)
- Implemented saving and loading serial letter db => serial letters are
  useable now in KWord :-)
- Fixes

Reggie, 4.10.1999:
--------------
- More work on spellchecking, works now somehow

Reggie, 5.10.1999:
--------------
- As text runaround contur didnŽt work anyway, I removed
  that option and added option to skip height of intersecting frames
- Improved speed of text running around frames a bit
- quite some speed improvements in formatting
- fixes in formatting
- fixes and improvements in line caching for drawing
- KWString does now some more caching => faster

Reggie, 6.10.1999:
--------------
- More fixes in line cache => more flicker freeness

Reggie, 19.10.1999:
-----------------
- Improvements for tables, still more needed

Reggie, 26.10.1999:
-----------------
- When selection text with keyboard Key_Home/Key_End
  are working as expected
- Frame borders with a width > 1 are drawn correctly again
- Fixed some crashing code

Reggie, 30.10.1999:
-----------------
- KRestrictedLine -> QLineEdit + QValidator
- Improved cursor navigation inside tables

Reggie, 8.11.1999:
-----------------
- When setting text attributes of a selected text only the chaged attribute(s)
  is changed, not the whole current format. So, if you have e.g. some bold and
  some italic text selected and change the color, only the color is changed
  and _not_ the attributes too (this was the case until now...).

Reggie, 10.11.1999
-----------------
- Saving and loading embedded parts works now

Reggie, 14.11.1999:
-----------------
- Implemented a menu entry to create a template from the document

Reggie, 17.11.1999:
-----------------
- Fixes

Reggie, 20.11.1999:
-----------------
Started working on automatically removing empty pages at the end. It
already works somehow, but the code is not used at the moment, as
there are some annoying bugs.

Reggie, 21.11.1999:
-----------------
- Shortcuts CTRL+B, CTRL+U, CTRL+I for bold, italic, underline works

Reggie, 27.11.1999
-----------------
- Fixed getting initial focus
- Got rid of the hack which inserts a space if you open an empty documen
  (not needed anymore)

Reggie, 28.11.1999
-----------------
- Small fix for scrolling (new selection stuff is not comitted yet...)

Reggie, 9.12.1999:
----------------
- Got rid of a shortcut which was used 3 times :-) (ALT + C)
- Implemented choosing fot through the menu using the KFontDialog
- The few unimplemented menu entries popup a message box with the info, that
  this entry is unimplemented
- Fixed creating table of contents
- Select all is now ALT + A, CTRL + A and CTRL + E work as expeced

Reggie, 19.12.1999:
-----------------
- It doesn't crash anymore when splitting a line which contains
  footnotes/endnotes - but footnotes/endnotes are a really broken, I think
  I need to rewrite that part

reggie, 27.12.1999:
-----------------
- Cache the important and often needed values of the font
  metrics in KWDisplayFont (like width, ascent, descent), so
  we don't need a call to the XServer (through QFontMetrcis)
  to get the same information again and again => biiig speed
  improvement

Reggie, 31.12.1999
----------------
- Disabled dropping for now as it crashed a lot and needs lots of work
  to get it really working

Reggie, 20.4.2000:
----------------
- Implemented basic zooming support. TODO: Go through
  sources and zoom all relevant values (all frames, pictures, etc.)